// processed by mwprepro or mwpreproC 

//	Copyright (c) 1982 Dyadic Systems Limited	

#include <machine.h>
#include <quadav.h>

unsigned resolve(a,b)
register unsigned a,b;
/*
	Resolve overstrikes
*/
{
 register unsigned r;
 if(a==b)return a;
 if(a==SP)return b;
 if(b==SP)return a;
 if(a>b)
	{
	 r=a;
	 a=b;
	 b=r;
	}
switch(a)
	{
	 case QUOTE	: switch(b)
		{
		 case POINT	: return SHRIEK;
		 case QUAD	: return QUADQUOTE;
		 default	: return 0;
		}
	 case UNDER	: switch(b)
		{
		 case A		:
		 case B		:
		 case C		:
		 case D		:
		 case E		:
		 case F		:
		 case G		:
		 case H		:
		 case I		:
		 case J		:
		 case K		:
		 case L		:
		 case M		:
		 case N		:
		 case O		:
		 case P		:
		 case Q		:
		 case R		:
		 case S		:
		 case T		:
		 case U		:
		 case V		:
		 case W		:
		 case X		:
		 case Y		:
		 case Z		:
				  return b|0x20;
		 case DELTA	: return DELTAU;
		 case EQ	: return MATCH;
		 case NE	: return NOTMATCH;
		 case EPSILON	: return EPSUBAR;
		 default	: return 0;
		}
	 case ZERO	: switch (b)
		{
		 case TILDE	: return ZILDE;
		 default	: return 0;
		}
	 case L		: switch (b)
		{
		 case MINUS	: return POUND;
		 default	: return 0;
		}
	 case S		: switch (b)
		{
		 case STILE	: return DOLLAR;
		 default	: return 0;
		}
	 case DELTA	: switch (b)
		{
		 case STILE	: return UPGRADE;
		 default	: return 0;
		}
	 case DIRESIS	: switch (b)
		{
		 case TILDE	: return COMM;
/* decided not to support these
		 case CIRCLE	: return OVER;
		 case STAR	: return POWER;
		 case DEL	: return DUAL;
		 case JOT	: return ON;
		 case TOP	: return CONV;
*/
		 default	: return 0;
		}
	 case LBRACKET	: switch (b)
		{
		 case JOT	: return LBRACE;
		 case RBRACKET	: return SQUISH;
		 default	: return 0;
		}
	 case SLASH	: switch (b)
		{
		 case MINUS	: return BSLASH;
		 default	: return 0;
		}
	 case SLOPE	: switch (b)
		{
		 case MINUS	: return BSLOPE;
		 case CIRCLE	: return TRANSPOSE;
		 default	: return 0;
		}
	 case LT	: switch (b)
		{
		 case GT	: return DIAMOND;
		 default	: return 0;
		}
	 case OR	: switch (b)
		{
		 case AND	: return DIAMOND;
		 case TILDE	: return NOR;
		 default	: return 0;
		}
	 case AND	: switch (b)
		{
		 case TILDE	: return NAND;
		 default	: return 0;
		}
	 case MINUS	: switch (b)
		{
		 case CIRCLE	: return BCIRCLE;
		 case LPAREN	: return LTACK;
		 case STILE	: return BSTILE;
		 case COMMA	: return BCOMMA;
		 case RPAREN	: return RTACK;
		 default	: return 0;
		}
	 case DIVIDE	: switch (b)
		{
		 case QUAD	: return DOMINO;
		 default	: return 0;
		}
	 case TILDE	: switch (b)
		{
		 case DEL	: return DELTILDE;
		 default	: return 0;
		}
	 case CIRCLE	: switch (b)
		{
		 case STAR	: return LOG;
		 case STILE	: return CIRCLESTILE;
		 default	: return 0;
		}
	 case DEL	: switch (b)
		{
		 case STILE	: return DGRADE;
		 default	: return 0;
		}
	 case JOT	: switch (b)
		{
		 case CAP	: return LAMP;
		 case BASE	: return HYDRANT;
		 case TOP	: return THORN;
		 case RBRACKET	: return RBRACE;
		 default	: return 0;
		}
	 case LSHOE	: switch (b)
		{
		 case STILE	: return CENT;
		 default	: return 0;
		}
	 case BASE	: switch (b)
		{
		 case TOP	: return IBEAM;
		 default	: return 0;
		}
	 default	: return 0;
	}
}


unsigned convmode;	// exit mode from last convtoav call 

unsigned convtoav(to, from, max)
register unsigned char	*to,	// destination string	
			*from;	// source string	
register unsigned	max;	// max characters to transfer 
{
/*
	copies from source to destination translating to av
	returns the length of the resulting string
	if max is less than the value returned the the copy
	will be incomplete
	note: tab characters can make the output bigger than the input
*/
register unsigned count=0,	// count of output characters 
		  bscount=0;	// count of unused backspaces 
register unsigned char c, new;
register unsigned aplmode=0;	// initial mode of input 0 implies ascii
				//			 1 implies apl	

while(c= *from++)
	{
	 if(32>c)switch(c)	// deal with control characters	
		{
		 case '\b':		// back space	
			 if(bscount<count)
				{
				 ++bscount;
				 to--;
				}
			 continue;
		 case '\t':		// tab		
				{
				 unsigned newcount;

				 newcount=(count-bscount+8)& ~7;
				 if(newcount>count)
					{
					 to+=bscount;
					 bscount=0;
					 while(count<newcount)
						{
						 if(count++ < max)*to = SP;
						 ++to;
						}
					}
				 else 
					{
					 newcount=count-newcount;
					 to+=bscount-newcount;
					 bscount=newcount;
					}
				}
			 continue;
		 case '\n':		// newline	
		 case '\r':		// cr		
			 new=NEWLINE;
			 break;
		 case '\016':
			 aplmode=1;
			 continue;
		 case '\017':
			 aplmode=0;
			 continue;
		 default:new=SQUISH;	// unrecognised control char 
			 break;
		}
	 else new=asctoav(c,aplmode);
	 if(!bscount)
		{
		 if(count<max)*to = new;
		 ++count;
		}
	 else
		{
		 if((count-bscount) < max)
			{
			 if(0==(c=resolve(*to,new)))c=new;
			 *to = c;
			}
		 bscount--;
		}
	 ++to;
	}
convmode=aplmode;	// set global exit mode 
return count;
}

unsigned convlen(from)
unsigned char *from;	// source string 
{
/*
	find length of converted string without copying anything
*/
return convtoav((unsigned char *)0, from, 0);
}

//	Copyright (c) 1982 Dyadic Systems Limited	

