
//	Copyright (c) 1982 Dyadic Systems Limited	

#include	<apl.h>
#undef		CHAR
#undef		BOOL			// name clash
#undef		LONG			// name clash
#include	<sys/types.h>
#include	<sys/stat.h>
#include	<errno.h>
#include	<stdio.h>

#if	defined(WATCOM)
#	include	<windows.h>
#	include	<winmain.h>
#endif//defined(WATCOM)

#include	<support.h>

#if	defined(MASSCOMP)
#	include	<sys/ioctl.h>	// to get FIONREAD on masscomp... 
#endif	// MASSCOMP 

#if	defined(AIXPS270)
#	define FIONREAD 0x4004667f// cant include ioctl.h - name clashes 
#endif	// AIXPS270 

#if	defined(BSD)
#	include	<sgtty.h>
#endif	// BSD 

#if	defined(DOS)
#	include	<stdio.h>
#	include	<language.cf>
#	include	"hardware.h"
#	include	"task.h"		// need these to shadow malloc() 
#endif	// DOS 

#if	defined(DOS)
#	define		PIPESIZE	0x7fffffff
#elif	defined(WATCOM)
#	define		PIPESIZE	(64*1024)
#else
#	define		PIPESIZE	4096
#endif//  

#if	defined(DALIGN)
#	define		DOUBWORDS	(sizeof(double)/sizeof(int))
#endif	// DALIGN 

unsigned long	XsessionWindowID;

jmp_buf		errbuff;
#ifdef	WATCOM
#	if	defined(__NT__)
	void * parentid;
#	else
	short unsigned parentid;
#	endif
	extern void task_error(HANDLE, int);
#else
unsigned	parentid;
#endif
static void	(*errorhandler)();	// allows user-defined error action 
static void	sigerror();		// default error handler	    
extern void *	malloc();
extern void	free();

unsigned normal_exit = 0;

//    s t a r t u p    
//	startup protocol as in "apl.h"					

#if	defined(DOS)
#elif	defined(WATCOM)

static void chk_normal_exit(int ignored)
{
	switch(normal_exit)
		{
	case 0:
		normal_exit = 1;		// make sure we dont recur
		task_error(parentid, AP_EXIT);
		break;
		}
}

static void call_chk_normal_exit(void)
	{
	chk_normal_exit(SIGHUP);
	}
#endif

startup(n_fns)
{
#if	defined(DOS)
	create_comms();
	parentid = fromapl();
	toapl(getpid());
#elif	defined(WATCOM)
	{
	extern HANDLE task_begin(void);
	extern int task_init(void *);
	extern WINMAIN win_main;
	extern void terminate(int);
	extern void init_version(void);

	init_version();		// set winNT so we don't get PROC_SETJMP

	(void)task_init(win_main.hInst);
	parentid = task_begin();
	if(0 == parentid)
		{
		printf("An AP must have a parent\n");
		exit(0);
		}
	signal(SIGHUP, terminate);		// clean exit
	signal(SIGABRT, chk_normal_exit);	// unclean exit
	atexit(call_chk_normal_exit);		// maybe unclean exit
	}
#else
	parentid = fromapl();
	toapl(getpid());
	setSigHandShake();
	signal(SIGINT, SIG_IGN);
	signal(SIGQUIT, SIG_IGN);
	signal(SIGHUP, SIG_DFL);
#endif	// DOS , WATCOM 

	toapl(n_fns);
}


//	d e f i n e	
define(apfn, syntax, fncode)
unsigned char *apfn;		// function name to appear in workspace	
int syntax, fncode;		// 'syntax'  as defined in "apl.h".	
{
	register int length;

	toapl(length = strlen(apfn));
	write(RSLTPIPE, apfn, length);
	toapl(syntax);
	toapl(fncode);

	if (syntax & XWID)
		XsessionWindowID = (unsigned long)fromapl();
}


//	g e t a r r a y   -   p u t a r r a y	

ARRAY *getarray()		// get(possibly nested) array from apl	
{
	register unsigned rank, *shape;
	register ARRAY *array, **ptr;
	extern int read();
	unsigned nwords;	// number of words remaining to read	
	ARRAY temp;

	if((nwords = fromapl()) == 0)	// read word count		
		return(0);		// left arg omitted		
	fields(&temp) = fromapl();	// read type/rank/eltype	

#ifdef	DALIGN
	if(temp.eltype == DOUB)
	{
		unsigned pad, *tmp;

		pad = (temp.rank+2)%DOUBWORDS;
		tmp = (unsigned *)alloc(--nwords+pad);
		array = (ARRAY *)(tmp+(DOUBWORDS-pad)%DOUBWORDS);
	}
	else
#endif	// DALIGN 
	array = alloc(--nwords);	// adjust word count &		
					// allocate space for array	
	shape = &(array->shape[0]);	// take pointer to shape	
	array->length = nwords;		// fill in array length		
	fields(array) = fields(&temp);	// and type/rank/eltype		

	nwords -= 2;			// decr words to be read	

	if(array->type == SIMPLE)
		pipewds(read, ARGSPIPE, shape, nwords);	// simple array 
	else
	{
		rank = array->rank;
		pipewds(read, ARGSPIPE, shape, rank);	// read shape	
		nwords -= rank;			// ... and decr count	

		/*	now recursively read in sub-arrays and
			install pointers in parent array.
		*/
		for(ptr = data(array, ARRAY *); nwords--;)
			*ptr++ = getarray();
	}
	return array;			// return pointer to array	
}


putarray(array)		// pass (possibly nested) array to apl		
ARRAY *array;		// arg is pointer to array to be transferred	
{
	register ARRAY **ptr;
	register unsigned rank, nwords;
	extern int write();

	if(array == 0)
		toapl(0);			// null result		
	else
	{
		toapl(nwords = array->length+1);	// pipe length word 
		if(array->type == SIMPLE)
			pipewds(write, RSLTPIPE, &fields(array), nwords-2);
		else
		{
			rank = array->rank;
			// pipe and shape 
			pipewds(write, RSLTPIPE, &fields(array), rank+1);
			nwords -= rank+1+2;	// words remaining	
			// recursively put each subarray		
			for(ptr = data(array, ARRAY *); nwords--;)
				putarray(*ptr++);
		}
	}
}


//  t h r o w a r r a y   -   f r e e a r r a y  

ARRAY *throwarray(thing)			// send the array to	
ARRAY *thing;					// APL & free the space	
{
	putarray(thing);
	return(freearray(thing));
}


ARRAY *freearray(thing)				// return an ARRAY to	
ARRAY *thing;					// the free space pool	
{
	unsigned n, n_elts = 1;
	ARRAY **ptr;

	if(thing == 0)				// don't try to free	
		return(0);			// if arg is null ptr	

#if	defined(WATCOM)		
	{
	unsigned *tp = (unsigned *)thing;

	if(1 & tp[-1])		// Watcoms malloc() use this bit to indicate use
		;
	else
		return 0;	// already free'd
	}
#endif

	switch(thing->type)
	{
	default:
		// hopefully already freed
		break;
	case NESTED: 				// recursively free	
						// subarrays first	
		for(n = thing->rank; n--;)
			n_elts *= thing->shape[n];

		ptr = &data(thing, ARRAY *)[n_elts];
		while(n_elts--)			// free subarrays in	
			freearray(*--ptr);	// reverse order	
	case SIMPLE:
		thing->type = 0; // we hope that free() does not mess with this
				 // enough to give NESTED or SIMPLE
#ifdef	DALIGN
		free((unsigned char *)((int)thing & -sizeof(double)));
#else
		free((unsigned char *)thing);	// free this array	
#endif	// DALIGN 
	}
	return 0;
}


//	m k a r r a y	

static unsigned char SHIFT[] =	// to convert no. of elements to no. of bits 
{	3, 	// CHAR 
	0, 	// BOOL 
	3, 	// SINT 
	4, 	// INTG 
	5, 	// LONG 
	6, 	// DOUB 
	PNTRlog	// PNTR 
};

ARRAY *mkarray(eltype, rank, shape)		// make an array in memory 
unsigned eltype;				// element type 
unsigned rank;					// array rank 
unsigned *shape;				// pointer to shape vector 
{
	register unsigned bound = 1, nwds, u, *ptr;
	register ARRAY *array;

	for(ptr = shape, u = rank; u--;)	// calc no of elements as 
		bound *= *ptr++;		// product of shape words 
#ifdef	OPUS
	nwds = SHIFT[eltype];			// size of element	
	if ((long)bound != (((long)bound << nwds) >> nwds))
		error(LIMIT);
#else
	if ((long)bound != (((long)bound << SHIFT[eltype]) >> SHIFT[eltype]))
		error(LIMIT);
#endif	// OPUS 
	nwds =					// calc no of words needed 
		2				// length and 
		+ rank +			// shape vector		
		(				// array elements	
			(
#ifndef	OPUS
				((long)bound << SHIFT[eltype])	// no of bits 
#else
				((long)bound << nwds)		// no of bits 
#endif	// OPUS 
				+(1 << PNTRlog)-1		// rounded up 
			) >> PNTRlog		// converted to words	
		) +
		(eltype == PNTR && bound == 0);	// prototype if null nested 

#ifdef	DALIGN
	if(eltype == DOUB)
	{
		unsigned pad, *tmp;

		pad = (rank+2)%DOUBWORDS;
		tmp = (unsigned *)alloc(nwds+pad);
		array = (ARRAY *)(tmp+(DOUBWORDS-pad)%DOUBWORDS);
	}
	else
#endif	// DALIGN 
	array = alloc(nwds);			// allocate space for array 
						// and fill in type ...	
	if(eltype == PNTR)			// zero so freearray() works 
		memset(array, 0, nwds * sizeof(unsigned));
	array->type = (eltype == PNTR ? NESTED : SIMPLE);
	array->length = nwds;			// length		
	array->eltype = eltype;			// element type		
	array->rank = rank;			// rank			

	memcpy(array->shape, shape, rank * sizeof(unsigned));

	return array;
}

/*	a r r a y b o u n d
	return number of elements in an array
	null nested arrays have one element anyway
*/

unsigned	arraybound(array)
ARRAY	*array;
{
	register unsigned	bd, n, *p;

	bd = 1;
	p = array->shape;

	for(n = array->rank; n--; ++p)
		bd *= *p;

	if(array->eltype == PNTR && !bd) bd = 1;
	return bd;
}

/*	a r r a y s t a r t
	return pointer to first byte of data portion
*/

unsigned char	*arraystart(array)
ARRAY	*array;
{
	return	(unsigned char *)(array->shape+array->rank);
}

//	u t i l i t i e s	


/*	handler

	install error handler - routine called by error().
	default action is to signal the error to APL and longjmp(errbuff).

	can be overridden by user routine allowing call to error() to be used
	by asynchronous tasks.

	if errorfn returns, default action taken.
*/

handler(errorfn)
void (*errorfn)();
{
	errorhandler = errorfn;
}

/*	error

	call error handler with error number.

	if errorfn returns, default action taken.
*/

error(errnumber)
int	errnumber;
{

	if(errorhandler)
		(*errorhandler)(errnumber);	// if this returns ...	

#if	defined(DOS)
	dos_comms_error(errnumber, 1);	// set the error return 
	longjmp(errbuff,errnumber);	// go back for next object 
#elif	defined(WATCOM)
	switch(errnumber)
		{
	default:
		{
		task_error(parentid, errnumber);// make a noise about it
		longjmp(errbuff,errnumber);	// go back for next object
		}
	case -1:				// -1 -> termination
		raise(SIGHUP);			// request task end
	case 0:					// ensure new function
		longjmp(errbuff,errnumber);	// go back for next object
						// quietly
		}
#else
	sigerror(errnumber);		// ... take default action	
#endif	// DOS , WATCOM 
}

#if	!defined(WATCOM)
static int errno2dyalog(int errno) { return errno; }
#endif

void filerror(void)
{
	error(100 + errno2dyalog(errno));
}



#if	!(defined(DOS) || defined(WATCOM))
/*	signal error to APL - default error handler
*/

static jmp_buf	envSigHandShake;		// buf for handshake 
static int	inerror;	// flag for handshake control 

static void sigerror(errnumber)
int errnumber;
{
	SIGTYPE (*savequit)();	// save current strong interrupt 
	SIGTYPE (*saveint)();	// save current weak interrupt	 

	savequit=signal(SIGQUIT,SIG_IGN); // dare not interrupt handshake 
	saveint=signal(SIGINT,SIG_IGN);
	
	inerror=1;		// so takeSigHandShake() knows who instigated 
	if(!setjmp(envSigHandShake))
		{
		 kill(parentid,SIGHANDSHAKE);	// stop apl		
		 pause();	// wait for apl to clean the result pipe
		}
	
	if(!setjmp(envSigHandShake))
		{
		 toapl(errnumber);	// write one word error code 
		 pause();		// wait for signal from apl  
		}
	gobble(ARGSPIPE);		// clean input pipe	
	kill(parentid,SIGHANDSHAKE);	// tell apl you have finished 

	signal(SIGQUIT,savequit);	// restore interrupts	
	signal(SIGINT,saveint);

	inerror=0;
	longjmp(errbuff,errnumber);	// go back for next object 
}


static takeSigHandShake()
{
	setSigHandShake();
	if(inerror)longjmp(envSigHandShake, 1);	// return to error 
	gobble(ARGSPIPE);			// apl issued an error 
	kill(parentid,SIGHANDSHAKE);		// tell apl you have finished 
	longjmp(errbuff,1);			// go get next input	
}

setSigHandShake()
{
	signal(SIGHANDSHAKE, takeSigHandShake);
}


static gobble(pipe)		// consume any bytes queued on pipe	
unsigned pipe;
{
	struct stat buf;
	unsigned char c;
	unsigned count;

	while(1)
	{
#ifdef	FIONREAD
		if(ioctl(pipe,FIONREAD,&count) == -1)
			return;			// illegal ioctl 
#else
	 	if(fstat(pipe, &buf) == -1)
			return;			// can't stat pipe	
	 	count = buf.st_size;
#endif	// FIONREAD 
		if(count == 0)
			return;			// finished		
		while(count--)
			read(pipe, &c, 1);	// throw away bytes	
	}
}


#endif	// DOS , WATCOM 


pipewds(iofn, pipe, buff, size)			// pipe words to or from ap 
int (*iofn)();					// read or write	
unsigned pipe;					// pipe number		
unsigned *buff;					// word ptr		
unsigned size;					// size in wds		
{
	register unsigned chunk, pipesize;
	register unsigned char *cbuf;
	register int nbytes;

	size *= sizeof(int);			// convert to bytes	
	cbuf = (unsigned char *)buff;
	pipesize = PIPESIZE - sizeof(int);

	while(chunk = size < pipesize ? size : pipesize)
	{
		// transfer a chunk at a time 

		nbytes = (*iofn)(pipe, cbuf, chunk);
		if(nbytes == chunk){		// success ! 
			size -= chunk;
			cbuf += chunk;
			pipesize = PIPESIZE;
		}
		else if (nbytes == 0)
		{
#ifndef	DOS	// if apl is finished on DOS then I never get control 
			kill(getpid(), SIGHUP);
#endif	// DOS 
			exit(0);		// EOF => apl finished 
		}
		else if (nbytes==-1 && errno==EINTR)
			continue;	// io interrupted try again 
		else
			exit(errno);	// give up 
	}
}


toapl(n)
unsigned n;
{
	int write();

	pipewds(write, RSLTPIPE, &n, 1);
}


unsigned fromapl()
{
	unsigned rslt;
	int read();

	pipewds(read, ARGSPIPE, &rslt, 1);
	return(rslt);
}


ARRAY *alloc(nwds)			// same as C library 'malloc'	
unsigned nwds;				// but with error check		
{
	unsigned char *p;

	if((p = malloc(nwds*sizeof(int))) == 0)
		error(LIMIT);

	return (ARRAY *)p;
}

#ifdef	DOS

pragma	Calling_convention(PASCAL);
extern void *	_mwmalloc(unsigned size);
extern void	_mwfree(void *ptr);
pragma	Calling_convention();

unsigned char *malloc(unsigned size)
{
return (unsigned char *)_mwmalloc(size);
}

void free(void * ptr)
{
_mwfree(ptr);
}

#endif	// DOS 

domain()	// return a domain error to apl	
{
	error(DOMAIN);
}

nonce()		// return a nonce error to apl	
{
	error(NONCE);
}

limit()		// return a limit error to apl	
{
	error(LIMIT);
}


#ifdef DOS
exit(int code)	// cover the exit function otherwise APL terminates 
{
// APL does not run APs as programs with their own PSPs 
unsigned char emess[] = "dont attempt to reuse an AP after an AP_EXIT\n";
for(;;)
	{
	error(AP_EXIT);
	write(2, emess, strlen(emess));
	}
}

syserror(n)
{
fprintf(stderr, "syserror %d\n", n);
exit(n);
}
#endif // DOS 

void terminate(int ignored)
{
	normal_exit = 1;
	exit(0);
}


syserror(n)
unsigned n;
{
	printf("via: syserror %u errno %u\n\r",n,errno);
	fflush(stdout);
	exit(3);
}

//	Copyright (c) 1982 Dyadic Systems Limited	
